import com.make.swing.MakeDialog;

import java.awt.Frame;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.IOException;
import javax.swing.Icon;
import javax.swing.JScrollPane;
import javax.swing.JEditorPane;
import javax.swing.Box;
import javax.swing.JOptionPane;
import javax.swing.JButton;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.BorderFactory;
import com.make.util.Streams;

class LicenseDialog extends MakeDialog {
    /***Constructor*********************/
    public LicenseDialog(Frame _f) {
	super(_f, "License", T_VIEW);
	try {
	    JEditorPane ep = new JEditorPane(getClass().getResource("COPYING"));
	    JScrollPane sp = new JScrollPane(ep);
	    sp.setPreferredSize(new Dimension(530, 500));
	    getContentPane().add("North", new JLabel("Please note that this license may not "+
						     "apply to additional modules!"));
	    getContentPane().add("Center", sp);
	} catch (IOException e) {
	    e.printStackTrace();
	}
	getContentPane().add("South", createButtonBox());
	pack();
    }
}

public class AboutDialog extends MakeDialog {
    /***CONST************************************/
    private static final String contentText
	= "<html>"+
	"<p>lean<b>edit</b> v1.6.10<br>"+
	"\u00a9 1999-2000 Max Kellermann<br>"+
	"<p>lean<b>edit</b> comes with ABSOLUTELY NO WARRANTY<br>"+
	"This is free software, and you are welcome to redistribute it<br>"+
	"under certain conditions; click on `License' for details."+
	"<p>This software uses the following libraries:<ul>"+
	"<li>Xerces 1.0.2 \u00a9 The Apache Software Foundation</li>"+
	"<li>FOP 0.12.1 \u00a9 The Apache Software Foundation</li>"+
	"<li>IBM LotusXSL 0.20.0 \u00a9 International Business Machines</li>"+
	"<li>Java Foundation Classes 1.1.1 \u00a9 Sun microsystems</li>"+
	"</ul>"+
	"<p>All trademarks are property of their respective owners."+
	"<p><br>Many thanks to the The Apache Software Foundation, "+
	"IBM alphaworks & developerworks and the Linux community."+
	"<p>For feedback contact max.kellermann@netcologne.de."+
	"</html>";
    /***properties******************************/
    /***Constructor***************************/
    public AboutDialog(final Frame _f) {
	super(_f, "About LeanEdit", T_VIEW);
	getContentPane().setBackground(Color.white);
	Icon logo = new ImageIcon(getClass().getResource("logo.gif"));
	JLabel logoLabel = new JLabel(logo);
	getContentPane().add("North", logoLabel);
	logoLabel.setHorizontalAlignment(logoLabel.RIGHT);
	JLabel text = new JLabel(contentText);
	getContentPane().add("Center", text);
	text.setBorder(BorderFactory.createEmptyBorder(10, 10, 20, 0));
	text.setPreferredSize(new Dimension(450, text.getPreferredSize().height));
	// buttons
	Box box = Box.createHorizontalBox();
	box.add(Box.createHorizontalGlue());
	JButton license = new JButton("License");
	license.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		new LicenseDialog(_f).show();
	    }
	});
	box.add(license);
	JButton close = new JButton("Close");
	close.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		setVisible(false);
	    }
	});
	box.add(close);
	close.requestFocus();
	getContentPane().add("South", box);
	getRootPane().setDefaultButton(close);
	pack();
    }
}
