import java.awt.Color;
import java.awt.Dimension;
import java.awt.BorderLayout;
import java.io.IOException;
import java.util.ResourceBundle;
import javax.swing.Icon;
import javax.swing.JFrame;
import javax.swing.Box;
import javax.swing.JOptionPane;
import javax.swing.JButton;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.BorderFactory;
import com.make.util.Streams;
import com.make.util.Debug;
import com.make.swing.StatusWindow;

/**
 * This class is derived from StatusWindow, but does not use it to show a
 * (possibly changing) status. Instead it overrides the createFrame()-method
 * in order to show just a short message about copyright and license while
 * the application starts up in a different frame.
 */
public class StartWindow extends StatusWindow {
    /***CONST************************************/
    /**
     * contains copyright and licensing information
     */
    private static final String contentText
	= "<html><p>lean<b>edit</b> v1.6.10<br>"+
	"\u00a9 1999-2000 Max Kellermann"+
	"<p>lean<b>edit</b> comes with ABSOLUTELY NO WARRANTY<br>"+
	"This is free software, and you are welcome to redistribute it<br>"+
	"under certain conditions; read the file `COPYING' for details.</html>";
    /***properties******************************/
    /***Constructor***************************/
    public StartWindow(ResourceBundle resources, Runnable job) {
	super(resources.getString("message.start"), 
	      resources.getString("application.name"), 0, false, job);
    }
    protected void createFrame() {
	frame = new JFrame(title);
	frame.setDefaultCloseOperation(frame.DO_NOTHING_ON_CLOSE);
	frame.getContentPane().setBackground(Color.white);
	// logo
	Icon logo = new ImageIcon(getClass().getResource("logo.gif"));
	JLabel logoLabel = new JLabel(logo);
	logoLabel.setHorizontalAlignment(logoLabel.RIGHT);
	frame.getContentPane().add("North", logoLabel);
	// content label
	JLabel contentLabel = new JLabel(contentText);
	frame.getContentPane().add("Center", contentLabel);
	contentLabel.setPreferredSize(new Dimension(400, 110));
	contentLabel.setBorder(BorderFactory.createEmptyBorder(10, 10, 20, 0));
	// text label
	label = new JLabel(text); text = null;
	frame.getContentPane().add("South", label);
	frame.pack();
    }
}
