package com.make.datamodel.embedded;

import java.io.IOException;
import java.io.InputStream;
import java.io.ByteArrayOutputStream;
import java.io.ByteArrayInputStream;
import java.util.Hashtable;
import java.util.Enumeration;
import org.w3c.dom.Node;
import org.xml.sax.SAXException;
import com.make.util.Streams;

public class CachedEmbeddedManager extends MemoryEmbeddedManager 
    implements ProxyEmbeddedManager {
    /***properties*******************************/
    protected EmbeddedManager original;
    protected String[] names;
    /***Constructor*****************************/
    public CachedEmbeddedManager(EmbeddedManager _em) { 
	original = _em;
    }
    public String toString() { return original.toString(); }
    /***ProxyEmbeddedManager*************************/
    public EmbeddedManager getOriginal() {
	return original;
    }
    /***EmbeddedManager***************************/
    public String[] getNames() throws IOException {
	if (names==null)
	    names = original.getNames();
	return names;
    }
    public Hashtable getSizes() throws IOException {
	return original.getSizes();
    }
    public boolean contains(String name) { 
	if (names==null)
	    try {
		names = original.getNames();
	    } catch (IOException e) {
		return false;
	    }
	for (int z=0; z<names.length; z++)
	    if (names[z].equals(name))
		return true;
	return false;
    }
    public void replaceEntry(String name, InputStream data)
	throws IOException {
	names = null;
	super.replaceEntry(name, data);
	original.replaceEntry(name, super.getEntry(name));
    }
    public InputStream getEntry(String name) throws IOException {
	InputStream is = super.getEntry(name);
	if (is==null) {
	    is = original.getEntry(name);
	    if (is==null) return null;
	    super.replaceEntry(name, is);
	    return super.getEntry(name);
	} else
	    return is;
    }
    public void replaceDocument(Node n) throws IOException {
	original.replaceDocument(n);
	super.replaceDocument(n);
    }
    public Node getDocument() throws IOException, SAXException {
	Node n = super.getDocument();
	if (n==null) {
	    n = original.getDocument();
	    if (n!=null)
		super.replaceDocument(n);
	}
	return n;
    }
    public boolean equals(Object o) { 
	if (o instanceof CachedEmbeddedManager)
	    return original.equals(((CachedEmbeddedManager)o).original);
	else
	    return original.equals(o);
    }
}
