package com.make.editor;

import java.awt.Frame;
import java.awt.Component;
import java.awt.BorderLayout;
import java.awt.LayoutManager;
import java.util.Enumeration;
import javax.swing.JPanel;
import javax.swing.Action;
import com.make.swing.InterfacePanel;
import com.make.swing.PanelContent;
import com.make.swing.SwingSession;

public abstract class DefaultPanel implements PanelContent {
    /***properties******************************/
    private SwingSession session;
    protected Enumeration sessionActions;
    protected InterfacePanel interfacePanel;
    protected JPanel panel;
    /***Constructor*****************************/
    public DefaultPanel(SwingSession _sess, InterfacePanel _ip, LayoutManager lm) {
	session = _sess;
	panel = new JPanel(lm, false);
	interfacePanel = _ip;
	interfacePanel.setContent(this);
	sessionActions = _sess.getActions();
	if (sessionActions!=null) {
	    interfacePanel.getButtonManager().installActions(sessionActions);
	    sessionActions = _sess.getActions();
	}
    }
    public DefaultPanel(SwingSession _sess, InterfacePanel _ip) {
	this(_sess, _ip, new BorderLayout());
    }
    /***Info**********************************/
    public final SwingSession getSwingSession() { return session; }
    public InterfacePanel getInterfacePanel() { 
	return interfacePanel;
    }
    public final Frame getFrame() { 
	return interfacePanel.getFrame(); 
    }
    /***PanelContent**************************/
    public Component getComponent() {
	return panel;
    }
    public boolean panelClosing() { 
	return true; 
    }
    public void panelClosed() {
	if (sessionActions!=null)
	    interfacePanel.getButtonManager().uninstallActions(sessionActions);
	interfacePanel = null;
    }
}
