package com.make.editor;

import java.io.IOException;
import java.io.File;
import java.util.Enumeration;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.xml.sax.SAXException;
import org.xml.sax.EntityResolver;
import com.make.xml.DocumentType;
import com.make.xml.FormatManager;
import com.make.editor.plugins.EditorPlugin;
import com.make.editor.plugins.PluginManager;
import com.make.editor.filter.Filter;

public interface EditorApplication {
    public PluginManager getPluginManager();
    public FormatManager getFormatManager();
    public EntityResolver getEntityResolver();
    public Enumeration getModules();
    public Enumeration getFilters();
    public void addFilter(Filter flt);
    public void removeFilter(Filter flt);
}
