package com.make.editor;

import java.util.Hashtable;
import java.net.URL;
import java.net.MalformedURLException;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Attr;
import com.make.xml.DOMUtil;
import com.make.xml.ConfigPath;
import com.make.util.Debug;
import com.make.editor.plugins.PluginManager;
import com.make.editor.plugins.EditorPlugin;

public class EditorDocumentView extends ConfigPath {
    /***properties***********************/
    protected PluginManager pluginManager;
    protected EditorDocumentType documentType;
    protected String name, title, plugin, description;
    protected Hashtable cache = new Hashtable();
    /***Constructor********************/
    public EditorDocumentView(PluginManager _pm) {
	super(null, null);
	pluginManager = _pm;
	name = "tree"; title = "Tree view";
	plugin = "tree";
    }
    public EditorDocumentView(EditorDocumentType _dt, Element vd) {
	super(_dt.get(vd.getAttribute("name")+"/"),
	      _dt.getApplication().getEntityResolver());
	documentType = _dt;
	pluginManager = documentType.getApplication().getPluginManager();
	name = vd.getAttribute("name");
	title = DOMUtil.getElementString(vd, "title");
	if (title==null)
	    title = name;
	plugin = DOMUtil.getElementString(vd, "plugin");
	if (plugin==null) {
	    if (Debug.DEBUG)
		System.err.println("WARNING: no plugin specified");
	    plugin = "tree";
	}
	description = DOMUtil.getElementString(vd, "description");
    }
    /***Info****************************/
    public String getName() { return name; }
    public String getTitle() { return title; }
    public String getDescription() { return description; }
    public EditorPlugin loadPlugin() {
	EditorPlugin pl = pluginManager.loadPlugin(plugin);
	if (pl==null)
	    pl = pluginManager.loadPlugin("tree");
	return pl;
    }
    /***ConfigPath**************************/
    public Object getDescription(String p) {
	Object o = super.getDescription(p);
	if (o instanceof Element) {
	    Element el = (Element)o;
	    if (el.getTagName().equals("redirect")) {
		o = getDescription(el.getAttribute("uri"));
		if (o!=null && p.indexOf('?')!=-1)
		    putDescription(p, o);
	    }
	}
	return o;
    }
}
