package com.make.editor;

import java.awt.Frame;
import java.util.Enumeration;
import java.beans.PropertyChangeListener;
import org.w3c.dom.Node;
import com.make.swing.ButtonManager;
import com.make.swing.InterfacePanel;
import com.make.editor.plugins.EditorComponent;

public interface EditorFrame {
    /***CONST***********************************/
    public static final String VIEW = "view";
    public static final String COMPONENT = "component";
    public static final String DOCUMENT = "document";
    /***EditorFrame*****************************/
    public EditorSession getSession();
    public InterfacePanel getInterfacePanel();
    public EditorDocumentView getView();
    public void registerComponent(Node key, EditorComponent ec);
    public void unregisterComponent(Node key, EditorComponent ec);
    public EditorComponent getComponent(Node key); //null: root component
    public EditorDocument getDocument();
    public void addActions(Enumeration enum);
    public void removeActions(Enumeration enum);
    public void addPropertyChangeListener(PropertyChangeListener l);
    public void removePropertyChangeListener(PropertyChangeListener l);
}
