package com.make.editor;

import java.io.InputStream;
import java.util.Enumeration;
import org.xml.sax.SAXException;
import org.w3c.dom.Document;
import com.make.xml.DOMUtil;
import com.make.swing.InterfacePanel;
import com.make.swing.bt.FrameDescription;

public class SubEditorFrame extends EditorPanel {
    /***static**********************************/
    protected static FrameDescription staticFrameDescription;
    static {
	// frame description
	try {
	    InputStream is = SubEditorFrame.class.getResourceAsStream("/frame.xml");
	    Document td = DOMUtil.parse(is);
	    staticFrameDescription = new FrameDescription(td.getDocumentElement());
	} catch (Exception e) {
	    e.printStackTrace();
	}
    }
    /***properties******************************/
    protected EditorFrame original;
    protected FrameDescription frameDescription;
    /***Constructor*****************************/
    public SubEditorFrame(EditorFrame _or, InterfacePanel _ip,
			  FrameDescription _fd) {
	super(_or.getSession(), _ip);
	original = _or;
	frameDescription = _fd;
	if (frameDescription!=null)
	    interfacePanel.addFrameDescription(frameDescription);
	for (Enumeration enum=getApplication().getModules(); enum.hasMoreElements();)
	    ((EditorModule)enum.nextElement()).install(this);
    }
    /***PanelContent**************************/
    public void panelClosed() {
	for (Enumeration enum=getApplication().getModules(); enum.hasMoreElements();)
	    ((EditorModule)enum.nextElement()).uninstall(this);
	if (frameDescription!=null)
	    interfacePanel.removeFrameDescription(frameDescription);
	super.panelClosed();
    }
}
