package com.make.editor.field;

import java.io.FilenameFilter;
import java.io.IOException;
import java.util.Vector;
import java.awt.Component;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.text.ParseException;
import javax.swing.JRadioButton;
import javax.swing.Box;
import javax.swing.ButtonGroup;
import javax.swing.ButtonModel;
import javax.swing.JTextField;
import org.w3c.dom.Element;
import com.make.swing.field.DefaultField;
import com.make.util.Strings;
import com.make.editor.EditorSession;
import com.make.editor.EditorDocumentType;
import com.make.xml.DOMUtil;

class RadioField extends DefaultField {
    /***properties*************/
    protected Box box = Box.createHorizontalBox();
    protected ButtonGroup buttonGroup = new ButtonGroup();
    /***Constructor*************/
    public RadioField(Element _s) {
	Element[] rbs = DOMUtil.getChildElements(_s, "radiobutton");
	for (int z=0; z<rbs.length; z++) {
	    Element rb = rbs[z];
	    JRadioButton bt = new JRadioButton(rb.getAttribute("caption"));
	    bt.addActionListener(this);
	    box.add(bt);
	    buttonGroup.add(bt);
	    String curValue = rb.getAttribute("value");
	    ButtonModel bm = bt.getModel();
	    bm.setActionCommand(curValue);
	}
	setComponent(box);
    }
    /***Slot*********************************/
    public void setValue(Object v) throws ParseException {
	String ac = v==null?null:v.toString();
	Component[] cps = box.getComponents();
	for (int z=0; z<cps.length; z++) {
	    JRadioButton bt = (JRadioButton)cps[z];
	    buttonGroup.setSelected(bt.getModel(), 
				    bt.getActionCommand().equals(ac));
	}
    }
    public Object getValue() throws ParseException {
	ButtonModel selection = buttonGroup.getSelection();
	return selection==null?null:selection.getActionCommand();
    }
}
