package com.make.editor.filter;

import java.io.IOException;
import java.io.File;
import java.io.InputStream;
import java.io.OutputStream;
import org.w3c.dom.Document;

public interface Filter {
    public String getDescription();
    public String getDefaultExtension();
    public int getMagicHeaderSize();
    public boolean accept(String sysId);
    public boolean identify(String sysId);
    public boolean identify(InputStream is) throws IOException;
    public boolean importAvailable(String format);
    public boolean exportAvailable(String format);
    public Document importFile(InputStream is, String format) throws IOException;
    public void exportFile(Document doc, OutputStream os) throws IOException;
}
