package com.make.editor.plugins;

import java.util.Vector;
import java.util.Enumeration;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import com.make.editor.EditorDocument;

public abstract class AbstractEditorCursor implements EditorCursor {
    /***properties***********************/
    protected Vector listeners = new Vector();
    protected EditorDocument[] selection = emptySelection;
    /***Constructor************************/
    /***Methods******************************/
    protected void fireStateChanged() {
	ChangeEvent evt = new ChangeEvent(this);
	for (Enumeration enum=listeners.elements(); enum.hasMoreElements();)
	    ((ChangeListener)enum.nextElement()).stateChanged(evt);
    }
    protected void setSelection(EditorDocument[] ed) {
	selection = ed;
	fireStateChanged();
    }
    /***EditorCursor***************************/
    public EditorDocument[] getSelection() {
	return selection;
    }
    public void addChangeListener(ChangeListener l) {
	listeners.addElement(l);
    }
    public void removeChangeListener(ChangeListener l) {
	listeners.removeElement(l);
    }
}
