package com.make.editor.plugins;

import java.util.Vector;
import java.util.Enumeration;
import java.awt.BorderLayout;
import java.awt.Frame;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JList;
import javax.swing.JDialog;
import javax.swing.JButton;
import javax.swing.JScrollPane;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.AbstractListModel;
import org.w3c.dom.Element;
import com.make.xml.DOMUtil;
import com.make.swing.MakeDialog;
import com.make.editor.EditorDocumentType;
import com.make.editor.EditorDocumentView;

public class ViewSelector extends JDialog {
    class ViewInfo extends MakeDialog {
	public ViewInfo(EditorDocumentView v) {
	    super(ViewSelector.this.frame, "Ansichtdetails", T_VIEW);
	    JPanel panel = new JPanel(gridBagLayout, false);
	    addDisabledText(panel, "Name:", v.getName());
	    addDisabledText(panel, "Titel:", v.getTitle());
	    addDisabledText(panel, "Beschreibung:", v.getDescription());
	    getContentPane().add("Center", panel);
	    getContentPane().add("South", createButtonBox());
	    pack();
	}
    }
    /***properties********************************/
    protected Frame frame;
    protected Vector views;
    protected JList list;
    protected int selectedIndex = -1;
    /***Constructor********************************/
    public ViewSelector(Frame owner, String title, String prompt, 
			Enumeration _v) {
	super(owner, title, true);
	frame = owner; 
	views = new Vector();
	while (_v.hasMoreElements())
	    views.addElement(_v.nextElement());
	// list
	list = new JList(new AbstractListModel() {
	    public int getSize() { return views.size(); }
	    public Object getElementAt(int index) { 
		return ((EditorDocumentView)views.elementAt(index)).getTitle();
	    }
	});
	getContentPane().add("Center", new JScrollPane(list));
	// buttons
	Box buttons = new Box(BoxLayout.X_AXIS);
	buttons.add(buttons.createHorizontalGlue());
	JButton button;
	buttons.add(button=new JButton("Details..."));
	button.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		final int idx = list.getSelectedIndex();
		if (idx==-1) return;
		EditorDocumentView v
		    = (EditorDocumentView)views.elementAt(idx);
		ViewInfo vi = new ViewInfo(v);
		vi.show();
	    }
	});
	buttons.add(button=new JButton("OK"));
	button.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		selectedIndex = list.getSelectedIndex();
		setVisible(false);
	    }
	});
	buttons.add(button=new JButton("Cancel"));
	button.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		setVisible(false);
	    }
	});
	// add to layout
	getContentPane().add("North", new JLabel(prompt));
	getContentPane().add("South", buttons);
	pack();
    }
    public EditorDocumentView getSelectedView() {
	return selectedIndex<0?null 
	    :(EditorDocumentView)views.elementAt(selectedIndex);
    }
    public static EditorDocumentView selectView(Frame owner, String title, String prompt, 
						Enumeration views) {
	ViewSelector ps = new ViewSelector(owner, title, prompt, views);
	ps.show();
	return ps.getSelectedView();
    }
}
