package com.make.editor.plugins.container;

import javax.swing.event.ListSelectionListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.ListSelectionModel;
import com.make.editor.EditorDocument;
import com.make.editor.plugins.AbstractEditorCursor;

public class ContainerCursor extends AbstractEditorCursor 
    implements ListSelectionListener {
    /***properties***************************/
    protected ContainerModel model;
    protected ListSelectionModel selectionModel;
    /***Constructor***************************/
    public ContainerCursor(ContainerModel _m, ListSelectionModel _sm) {
	model = _m; selectionModel = _sm;
	selectionModel.addListSelectionListener(this);
    }
    public void setModel(ContainerModel _cm) {
	model = _cm;
	if (getSelection().length>0)
	    setSelection(emptySelection);
    }
    /***ListSelectionListener********************/
    public void valueChanged(ListSelectionEvent evt) {
	if (evt.getValueIsAdjusting())
	    return;
	if (model==null) {
	    if (getSelection().length>0)
		setSelection(emptySelection);
	} else {
	    final int idx0 = selectionModel.getMinSelectionIndex();
	    if (idx0==-1) {
		setSelection(emptySelection);
		return;
	    }
	    final int idx1 = selectionModel.getMaxSelectionIndex();
	    int[] sel = new int[idx1-idx0+1];
	    int count = 0;
	    for (int z=idx0; z<=idx1; z++)
		if (selectionModel.isSelectedIndex(z))
		    sel[count++] = z;
	    EditorDocument[] docs = new EditorDocument[count];
	    for (int z=0; z<count; z++)
		docs[z] = model.getItem(sel[z]);
	    setSelection(docs);
	}
    }
}



