package com.make.editor.plugins.list;

import javax.swing.ListModel;
import javax.swing.event.ListDataListener;
import javax.swing.event.ListDataEvent;
import org.xml.sax.SAXException;
import org.apache.xalan.xpath.XPath;
import org.w3c.dom.Node;
import org.w3c.dom.Element;
import com.make.xml.DOMUtil;
import com.make.xml.XPathUtil;
import com.make.editor.EditorDocument;
import com.make.editor.plugins.EditorComponent;
import com.make.editor.plugins.container.ContainerModel;
import com.make.editor.plugins.container.DefaultContainerModel;

public class ContainerListModel extends DefaultContainerModel 
    implements ListModel {
    /***properties***************************/
    protected XPath itemPath;
    /***Constructor*****************************/
    public ContainerListModel(EditorComponent _ec) {
	super(_ec);
    }
    public void setDocument(EditorDocument _d, Element vd)
	throws SAXException {
	try {
	    itemPath = vd==null
		?null
		:XPathUtil.parse(DOMUtil.getDeepString(vd, "item/@caption"));
	} finally {
	    reload();
	}
	super.setDocument(_d, vd);
    }
    /***ListModel************************************/
    public int getSize() { 
	return getItemCount();
    }
    public Object getElementAt(int index) {
	Node n = getItem(index).getNode();
	try {
	    return XPathUtil.execute(itemPath, n);
	} catch (SAXException e) {
	    e.printStackTrace();
	    return n;
	}
    }
    public void addListDataListener(ListDataListener l) {
	super.addListDataListener(l);
    }
    public void removeListDataListener(ListDataListener l) {
	super.removeListDataListener(l);
    }
}

