package com.make.editor.plugins.list;

import java.awt.Component;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.text.ParseException;
import javax.swing.JList;
import org.w3c.dom.Node;
import org.w3c.dom.Element;
import org.xml.sax.SAXException;
import org.apache.xalan.xpath.XPath;
import com.make.xml.DOMUtil;
import com.make.xml.XPathUtil;
import com.make.swing.bt.FrameDescription;
import com.make.swing.InterfacePanel;
import com.make.swing.DialogInterfacePanel;
import com.make.editor.EditorSession;
import com.make.editor.EditorDocument;
import com.make.editor.EditorDocumentView;
import com.make.editor.EditorFrame;
import com.make.editor.SubEditorFrame;
import com.make.editor.plugins.AbstractEditorCursor;
import com.make.editor.plugins.ComponentListener;
import com.make.editor.plugins.ComponentEvent;
import com.make.editor.plugins.container.ContainerModel;
import com.make.editor.plugins.container.DefaultContainerModel;
import com.make.editor.plugins.container.ContainerCursor;
import com.make.editor.plugins.container.AbstractListComponent;

public class ListComponent extends AbstractListComponent 
    implements MouseListener {
    /***properties*****************************/
    protected XPath itemPath;
    protected ContainerListModel model = new ContainerListModel(this);
    protected JList list = new JList(model);
    /***Constructor***************************/
    public ListComponent(EditorFrame _ef) {
	super(_ef);
	registerInputComponent(list);
	list.addMouseListener(this);
	setModel(model, list.getSelectionModel());
    }
    protected synchronized void reload() {
	model.reload();
    }
    /***MouseListener*********************************/
    public void mouseClicked(MouseEvent evt) {
	if (evt.getClickCount()==2)
	    editElement(getSelectedIndex());
    }
    public void mouseEntered(MouseEvent evt) {}
    public void mouseExited(MouseEvent evt) {}
    public void mousePressed(MouseEvent evt) {}
    public void mouseReleased(MouseEvent evt) {}
    /***EditorComponent********************************/
    public synchronized void setDocument(EditorDocument _doc) {
	super.setDocument(_doc);
	// remove old
	try {
	    model.setDocument(null, null);
	} catch (SAXException e) {
	    e.printStackTrace();
	}
	itemPath = null;
	// config
	Element vd = (Element)getViewDescription("list");
	if (vd!=null) {
	    loadActions(DOMUtil.getUniqueTag(vd, "actions"));
	    loadKeyBindings(list, DOMUtil.getUniqueTag(vd, "keybindings"));
	    // item
	    Element it = DOMUtil.getUniqueTag(vd, "item");
	    try {
		itemPath = it==null
		    ?null
		    :XPathUtil.parse(it.getAttribute("caption"));
	    } catch (SAXException e) {
		itemPath = null;
		e.printStackTrace();
	    }
	    // model
	    try {
		model.setDocument(_doc, vd);
	    } catch (SAXException e) {
		e.printStackTrace();
	    }
	}
    }
    public Component getComponent() { 
	return list;
    }
}
