package com.make.editor.plugins.splitpane;

import java.awt.Component;
import java.awt.Frame;
import javax.swing.Action;
import javax.swing.JSplitPane;
import javax.swing.text.TextAction;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;
import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import com.make.editor.EditorFrame;
import com.make.editor.EditorApplication;
import com.make.editor.plugins.EditorPlugin;
import com.make.editor.plugins.EditorComponent;
import com.make.editor.plugins.ContainerComponent;
import com.make.editor.EditorDocument;
import com.make.editor.plugins.PluginManager;
import com.make.xml.DOMUtil;

class SplitPaneComponent extends ContainerComponent {
    /***properties*********************************/
    protected JSplitPane splitPane;
    /***Constructor*******************************/
    public SplitPaneComponent(EditorFrame _ef) {
	super(_ef);
    }
    /***EditorComponent****************************/
    public void setDocument(EditorDocument _doc) {
	super.setDocument(_doc);
	// read view
	Element vd = (Element)getViewDescription("splitpane");
	Element cps = DOMUtil.getUniqueTag(vd, "components");
	Element[] el = DOMUtil.getChildElements(cps);
	if (el.length!=2)
	    throw new Error("component count = "+el.length+", should be 2");
	Component e1 = createComponent(null, el[0]);
	Component e2 = createComponent(null, el[1]);
	splitPane = new JSplitPane(JSplitPane.VERTICAL_SPLIT, true, e1, e2);
    }
    public Component getComponent() { return splitPane; }
}
