package com.make.editor.plugins.table;

import org.w3c.dom.Node;
import org.w3c.dom.Element;
import org.xml.sax.SAXException;
import org.apache.xalan.xpath.XPath;
import com.make.xml.DOMUtil;
import com.make.xml.XPathUtil;
import com.make.swing.field.Field;
import com.make.swing.il.InputLink;
import com.make.swing.il.InputLinkFactory;
import com.make.swing.il.FieldInputLink;

public abstract class AbstractColumn implements Column {
    /***static******************************/
    public static Column createColumn(Element cd, InputLinkFactory ilf) {
	String type = cd.getTagName();
	if (type.equals("column") || type.equals("xpathcolumn"))
	    return new XPathColumn(cd, ilf);
	else if (type.equals("choosecolumn"))
	    return new ChooseColumn(cd, ilf);
	else if (type.equals("nullcolumn"))
	    return new NullColumn(cd);
	else {
	    System.err.println("WARNING: unknown table column type "+type);
	    return new NullColumn(cd);
	}
    }
    /***properties*********************/
    protected String caption;
    /***Constructor*************************/
    public AbstractColumn(Element c) {
	caption = DOMUtil.getLocalizedElementString(c, "caption");
    }
    /***Column*****************************/
    public String getCaption() { return caption; }
}
