package com.make.editor.plugins.table;

import org.w3c.dom.Node;
import org.w3c.dom.Element;
import org.xml.sax.SAXException;
import org.apache.xalan.xpath.XPath;
import com.make.xml.DOMUtil;
import com.make.xml.XPathUtil;
import com.make.swing.field.Field;
import com.make.swing.il.InputLink;
import com.make.swing.il.InputLinkFactory;
import com.make.swing.il.FieldInputLink;

public class ChooseColumn extends AbstractColumn {
    /***CONST*****************************/
    protected static final NullColumn nullColumn = new NullColumn(null);
    /***properties*********************/
    protected XPath[] conditions;
    protected Column[] columns;
    /***Constructor*************************/
    public ChooseColumn(Element c, InputLinkFactory ilf) {
	super(c);
	Element chs = DOMUtil.getUniqueTag(c, "choose");
	Element[] wh = DOMUtil.getChildElements(chs);
	conditions = new XPath[wh.length];
	columns = new Column[wh.length];
	for (int z=0; z<wh.length; z++) 
	    try {
		if ("when".equals(wh[z].getTagName()))
		    conditions[z] = XPathUtil.parse(wh[z].getAttribute("test"));
		columns[z] = createColumn(DOMUtil.getChildElements(wh[z])[0], ilf);
	    } catch (Exception e) {
		System.err.println("error while loading column "+z);
		e.printStackTrace();
	    }
    }
    /***Internal***************************/
    protected Column findColumn(Node row) {
	for (int z=0; z<conditions.length; z++)
	    try {
		if (conditions[z]==null ||
		    XPathUtil.execute(conditions[z], row).bool())
		    return columns[z];
	    } catch (Exception e) {
		e.printStackTrace();
	    }
	return nullColumn;
    }
    /***Column*****************************/
    public boolean isEditable(Node row) { 
	return findColumn(row).isEditable(row);
    }
    public Object getValue(Node row) {
	return findColumn(row).getValue(row);
    }
    public void setValue(Node row, Object value) {
	findColumn(row).setValue(row, value);
    }
    public Field getField(Node row) {
	return findColumn(row).getField(row);
    }
}
