package com.make.editor.plugins.table;

import org.w3c.dom.Node;
import org.w3c.dom.Element;
import org.xml.sax.SAXException;
import org.apache.xalan.xpath.XPath;
import com.make.xml.DOMUtil;
import com.make.xml.XPathUtil;
import com.make.swing.field.Field;
import com.make.swing.il.InputLink;
import com.make.swing.il.InputLinkFactory;
import com.make.swing.il.FieldInputLink;

public class XPathColumn implements Column {
    /***properties*********************/
    protected String caption;
    protected XPath path;
    protected String pathString;
    protected Field field;
    protected boolean editable;
    /***Constructor*************************/
    public XPathColumn(Element c, InputLinkFactory ilf) {
	caption = DOMUtil.getLocalizedElementString(c, "caption");
	pathString = DOMUtil.getElementString(c, "path");
	try {
	    path = XPathUtil.parse(DOMUtil.getElementString(c, "path"));
	} catch (SAXException e) {
	    e.printStackTrace();
	}
	if (DOMUtil.childTagExists(c, "field")) {
	    InputLink il = ilf.createInputLink(c);
	    if (il!=null)
		field = ((FieldInputLink)il).getField();
	}
	editable = !"no".equals(c.getAttribute("editable"));
    }
    /***Column*****************************/
    public String getCaption() { return caption; }
    public boolean isEditable(Node row) { return editable; }
    public Object getValue(Node row) {
	try {
	    return path==null
		?null
		:XPathUtil.execute(path, row).str();
	} catch (SAXException e) {
	    e.printStackTrace(); return null;
	}
    }
    public void setValue(Node row, Object value) {
	DOMUtil.setDeepString(row, pathString, (String)value);
	//TODO: besser parsen
    }
    public Field getField(Node row) {
	return field;
    }
}
