package com.make.editor.plugins.text;

import java.awt.Font;
import com.make.editor.plugins.text.tree.StyleElement;
import com.make.editor.plugins.text.tree.SwingText;
import com.make.editor.plugins.text.tree.SwingDocument;
import com.make.editor.EditorFrame;
import com.make.swing.text.TextComponent;
import com.make.swing.text.EditorKit;
import com.make.swing.text.Document;
import com.make.swing.text.Element;
import com.make.swing.text.TextUI;
import com.make.swing.text.BasicTextUI;

public class XmlTextPane extends TextComponent {
    protected class XmlTextUI extends BasicTextUI {
	protected XmlTextUI(EditorKit ek) {
	    super(ek);
	}
	public Font getFont(TextComponent t, Element el) {
	    return styles.getFont(el);
	}
    }
    /***properties**************************/
    protected EditorFrame editorFrame;
    protected boolean paintAll = false;
    protected TextEditorStyleSet styles;
    /***Constructor******************************/
    public XmlTextPane(EditorKit _ek, Document _doc, 
		       TextEditorStyleSet _ss, EditorFrame _ef) { 
	super(_ek);
	editorFrame = _ef;
	styles = _ss;
	setDocument(_doc);
    }
    /***info*********************************************/
    public EditorFrame getEditorFrame() { return editorFrame; }
    public void setPaintAll(boolean pa) {
	if (paintAll!=pa) {
	    paintAll = pa;
	    getUI().rebuild();
	}
    }
    public boolean getPaintAll() { return paintAll; }
    /***TextComponent************************************/
    protected TextUI createUI() {
	return new XmlTextUI(getEditorKit());
    }
    public void replaceSelection(String content, String style) {
	if (content!=null && style!=null) {
	    StyleElement st = new StyleElement((SwingDocument)getDocument(), style);
	    st.insertChild(new SwingText((SwingDocument)getDocument(), content, false), null);
	    super.replaceSelection(st);
	} else
	    super.replaceSelection(content, style);
    }
    /***Scrollable******************************************/
    public boolean getScrollableTracksViewportWidth() { return true; }
    public boolean getScrollableTracksViewportHeight() { return false; }
};
