package com.make.editor.plugins.text.tree;

import com.make.swing.text.Element;
import com.make.swing.text.DocumentEvent;
import com.make.swing.text.SplitNotSupportedException;

public class BreakElement extends ElementSwingElement {
    /***Constructor*****************************/
    public BreakElement(org.w3c.dom.Element _el, SwingDocument _doc) {
	super(_el, _doc, 1, true);
	setStyle(_doc.getStyle(_el.getTagName()));
    }
    /***SwingElement****************************************/
    public void getText(StringBuffer sb, int offset, int length) 
	throws javax.swing.text.BadLocationException {
	if (offset<getStartOffset()) 
	    throw new javax.swing.text.BadLocationException("offset<start", offset);
	if ((offset+length)>getEndOffset()) 
	    throw new javax.swing.text.BadLocationException("offset+length>end", offset);
	if (length>0)
	    sb.append(' ');
    }
    protected Element createEmptyInstance(org.w3c.dom.Element el) {
	return new BreakElement(el, (SwingDocument)getDocument());
    }
    public Element split(int offset, DocumentEvent evt) 
	throws SplitNotSupportedException {
	throw new SplitNotSupportedException(this, offset);
    }
}
