package com.make.editor.plugins.text.tree;

import javax.swing.text.BadLocationException;
import com.make.swing.text.DocumentEvent;
import com.make.swing.text.ContainerChange;
import com.make.swing.text.Element;
import com.make.swing.text.SplitNotSupportedException;

public class FixedText extends Element {
    /***properties*****************************/
    protected String text;
    /***Constructor****************************/
    public FixedText(SwingDocument _doc, String _t) {
	super(_doc, _t.length(), true);
	text = _t;
    }
    public String getText() { return text; }
    /***Element******************************/
    protected int insertSpaceChild(int index, DocumentEvent evt,
				   ContainerChange chg) {
	throw new InternalError();
    }
    public Element split(int offset, DocumentEvent evt) 
	throws SplitNotSupportedException {
	throw new SplitNotSupportedException(this, offset);
    }
    public void getText(StringBuffer sb, int offset, int length) 
	throws BadLocationException {
	offset -= getStartOffset();
	sb.append(text.substring(offset, length));
    }
    protected Element createEmptyInstance() {
	throw new InternalError();
    }
}
