package com.make.editor.plugins.text.tree;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.text.Position;
import javax.swing.text.BadLocationException;
import com.make.swing.text.Element;
import com.make.swing.text.Document;
import com.make.swing.text.DocumentEvent;
import com.make.swing.text.TextComponent;

public class LinkElement extends ElementSwingElement {
    /***Constructor********************************/
    public LinkElement(org.w3c.dom.Element _el, SwingDocument _doc) {
	super(_el, _doc, 0);
    }
    /***Format****************************************/
    protected Element createEmptyInstance(org.w3c.dom.Element el) {
	return new LinkElement(el, (SwingDocument)getDocument());
    }
    /***Menu*******************************************/
    public void fillMenu(TextComponent editor, int context, 
			 int pos, Position.Bias bias, JPopupMenu menu) 
	throws BadLocationException {
	// remove style
	String title = (String)getAttribute((Object)"title");
	if (title==null) title = "Link";
	JMenuItem mi;
	mi = new JMenuItem(title+" entfernen");
	mi.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt2) {
		Document doc = getDocument();
		try {
		    doc.beginUpdate();
		    DocumentEvent evt = new DocumentEvent(doc);
		    getParent().removeStyle(getParent().indexOf(LinkElement.this), evt);
		    if (evt.isValid())
			doc.fireDocumentChanged(evt);
		} finally {
		    doc.endUpdate();
		}
	    }
	});
	menu.add(mi);
	super.fillMenu(editor, context, pos, bias, menu);
    }
}
