package com.make.editor.plugins.text.tree;

import java.util.Enumeration;
import java.util.Vector;
import org.w3c.dom.Node;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.NodeList;
import org.w3c.dom.Entity;
import org.w3c.dom.EntityReference;
import javax.swing.text.BadLocationException;
import com.make.swing.text.Element;
import com.make.swing.text.Document;
import com.make.swing.text.DocumentEvent;
import com.make.swing.text.SplitNotSupportedException;

public class SwingEntityElement extends NodeSwingElement {
    /***properties*******************************/
    protected Entity entity;
    /***Constructor********************************/
    public SwingEntityElement(Entity _el, SwingDocument _doc) {
	super(_el, _doc, 0, "entity");
    }
    public SwingEntityElement(EntityReference _el, SwingDocument _doc) {
	super(_el, _doc, 0, "entity");
    }
    protected void loadChildren() {
	if (getXmlNode() instanceof Entity) {
	    entity = (Entity)getXmlNode();
	} else {
	    EntityReference ref = (EntityReference)getXmlNode();
	    NamedNodeMap nnm = ref.getOwnerDocument().getDoctype().getEntities();
	    entity = (Entity)nnm.getNamedItem(ref.getNodeName());
	}
	loadChildren(entity.getChildNodes());
    }
    /***Format****************************************/
    protected Element createEmptyInstance() {
	throw new InternalError("can't split entity");
    }
    /***Edit******************************************/
    public boolean embedSplit(Element parent, int start, int end,
			      DocumentEvent evt) {
	return false;
    }
    public Element split(int offset, DocumentEvent evt) 
	throws SplitNotSupportedException {
	throw new SplitNotSupportedException(this, offset);
    }
    public boolean insertString(int offset, String str, DocumentEvent evt) 
	throws BadLocationException {
	return false;
    }
    public void remove(int offset, int length, DocumentEvent evt) 
	throws BadLocationException {
    }
    /***NodeSwingElement*****************************/
    public Node copyXmlNode(org.w3c.dom.Document doc, int start, int end) 
	throws BadLocationException { 
	return doc.createEntityReference(entity.getNodeName());
    }
    public boolean pasteNode(int pos, Node n, DocumentEvent evt) 
	throws BadLocationException {
	return false;
    }
}
