package com.make.editor.plugins.text.tree;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;
import javax.swing.ButtonGroup;
import javax.swing.JMenuItem;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.JMenu;
import javax.swing.JPopupMenu;
import javax.swing.text.BadLocationException;
import java.util.Hashtable;
import java.util.Enumeration;
import com.make.xml.DocumentType;
import com.make.xml.ElementType;
import com.make.editor.plugins.text.TextEditorStyleSet;
import com.make.util.Debug;
import com.make.swing.text.Element;
import com.make.swing.text.Document;
import com.make.swing.text.DocumentEvent;
import com.make.swing.text.ContainerChange;
import com.make.swing.text.SplitNotSupportedException;
import com.make.swing.text.TextComponent;

public class TableCellElement extends ElementSwingElement {
    public static class CellEnd extends Element {
	public CellEnd(Document _doc) {
	    super(_doc, 1, true);
	}
	/***Element*********************************/
	public String getName() { return "CellEnd"; }
	public void getText(StringBuffer sb, int offset, int length) {
	    if (length>=1)
		sb.append("\t");
	}
	protected int insertSpaceChild(int index, DocumentEvent evt,
				       ContainerChange chg) {
	    throw new InternalError();
	}
	/***Format****************************************/
	protected Element createEmptyInstance() {
	    throw new IllegalStateException();
	}
    }
    /***properties*********************************/
    protected CellEnd cellEnd;
    /***Constructor*************************/
    public TableCellElement(org.w3c.dom.Element _e, SwingDocument _doc) {
	super(_e, _doc, 0);
	insertChild(cellEnd = new CellEnd(_doc), null);
    }
    /***Info******************************************/
    public boolean childConservationPossible(Element child) {
	if (child==cellEnd)
	    return false;
	return super.childConservationPossible(child);
    }
    public boolean canInsertAt(int pos) throws BadLocationException {
	return super.canInsertAt(pos) &&
	    pos<=cellEnd.getStartOffset();
    }
    public boolean ignoreOuterSpaces() { return true; }
    /***Format****************************************/
    protected Element createEmptyInstance(org.w3c.dom.Element el) { 
	throw new IllegalStateException(); 
    }
    /***Element*****************************************/
    public void removeChild(int index) {
	if (Debug.DEBUG && index>=(getElementCount()-1))
	    throw new InternalError("tried to remove cellEnd");
	super.removeChild(index);
    }
    public boolean insertString(int offset, String str, DocumentEvent evt) 
	throws BadLocationException {
	if (offset>=getEndOffset())
	    return false;
	else
	    return super.insertString(offset, str, evt);
    }
}
