package com.make.editor.plugins.text.view;

import java.awt.Shape;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Toolkit;
import javax.swing.text.BadLocationException;
import com.make.swing.text.TextComponent;
import com.make.swing.text.Element;
import com.make.swing.text.Document;
import com.make.swing.text.DocumentEvent;
import com.make.swing.text.TextUI;
import com.make.swing.text.view.View;
import com.make.swing.text.view.ViewFactory;

public final class NullView extends View {
    /***properties****************************/
    protected FontMetrics metrics;
    /***Constructor******************************/
    public NullView(Element el) { super(el); }
    /***View******************************************/
    public float getPreferredSpan(int axis) { 
	if (metrics==null) {
	    TextComponent target = getContainer();
	    Toolkit toolkit = target.getToolkit();
	    TextUI ui = target.getUI();
	    Element attr = getElement();
	    Document doc = getDocument();
	    metrics = toolkit.getFontMetrics(ui.getFont(target, attr));
	}
	if (axis==Y_AXIS && metrics!=null)
	    return metrics.getHeight();
	return 0;
    }
    public Shape modelToView(int pos, Shape a) {
	return a;
    }
    public void paint(Graphics g, Shape allocation) {}
    public int viewToModel(float x, float y, Shape a) {
	return getElement().getStartOffset();
    }
    public int getNextVisualPositionFrom(int pos, int direction) 
	throws BadLocationException {
	switch (direction) {
	case NORTH: case SOUTH:
	    return pos==-1 ? getStartOffset() : -1;
	case WEST:
	    return pos==-1 || pos>getStartOffset() ? getStartOffset() : -1;
	case EAST:
	    return pos==-1 ? getStartOffset() : -1;
	default:
	    throw new IllegalArgumentException("Bad direction: " + direction);
	}
    }
    public void documentChanged(DocumentEvent evt, Shape a, ViewFactory vf) {}
}
