package com.make.editor.plugins.text.view;

import com.make.editor.plugins.text.tree.NumberedList;
import com.make.swing.text.view.ViewFactory;
import com.make.swing.text.Element;
import com.make.swing.text.view.View;
import com.make.swing.text.view.ParagraphView;

public class NumberedParagraphView extends ParagraphView {
    /***Constructor****************************/
    public NumberedParagraphView(Element elem, ViewFactory vf) {
	super(elem, vf);
    }
    protected void syncPrefix() {
	if (getParent()!=null) {
	    Element pel = getParent().getElement();
	    final int idx = pel.indexOf(getElement());
	    String pr;
	    if (pel instanceof NumberedList) {
		NumberedList nl = (NumberedList)pel;
		pr = nl.formatIndex(idx);
	    } else
		pr = idx+".";
	    setPrefix(pr);
	}
	super.syncPrefix();
    }
    public void setParent(View parent) {
	super.setParent(parent);
	syncPrefix();
    }
}
