package com.make.editor.plugins.text.view;

import java.awt.Shape;
import com.make.util.Interval;
import com.make.editor.plugins.text.tree.NumberedList;
import com.make.swing.text.DocumentEvent;
import com.make.swing.text.ContainerChange;
import com.make.swing.text.view.ViewFactory;
import com.make.swing.text.view.BoxView;
import com.make.swing.text.view.VerticalView;
import com.make.swing.text.Element;

public class SectionView extends BoxView implements VerticalView {
    /***Constructor***********************/
    public SectionView(Element body) { 
	super(body, Y_AXIS);
    }
    /***View************************************************/
    public int getBreakWeight(int axis, int offset, float pos, float len) {
	if (axis==getAxis())
	    return super.getBreakWeight(axis, offset, pos, len);
	else
	    return ForcedBreakWeight;
    }
    /***CompositeView***************************************/
    protected void forwardUpdate(DocumentEvent evt, ContainerChange chg, 
				 Shape a, ViewFactory f) {
	// Alle Zahlen neu malen
	if (getElement() instanceof NumberedList && chg!=null) {
	    Interval c = chg.getChanged();
	    c.include(0);
	    c.include(getPoolViewCount()-1);
	}
	super.forwardUpdate(evt, chg, a, f);
    }
}
