package com.make.swing;

import java.awt.event.ActionListener;
import javax.swing.KeyStroke;
import javax.swing.JComponent;
import com.make.util.Debug;

public class KeyStrokeButton implements GenericButton {
    /***properties****************************/
    protected JComponent component;
    protected KeyStroke keyStroke;
    protected String command;
    protected int condition;
    protected ActionListener listener;
    /***Constructor**************************/
    public KeyStrokeButton(JComponent _c, String _cmd, 
			   KeyStroke _ks, int _cond) { 
	component = _c; command = _cmd;
	keyStroke = _ks; condition = _cond;
    }
    /***GenericButton*************************/
    public Object getActionSource() { return component; }
    public String getActionCommand() { return command; }
    public void addActionListener(ActionListener al) {
	if (listener==null) {
	    component.registerKeyboardAction(al, command, keyStroke, condition);
	    listener = al;
	} else if (Debug.DEBUG)
	    System.err.println("WARNING: duplicate register of keystroke "+keyStroke);
    }
    public void removeActionListener(ActionListener al) {
	if (listener==al) {
	    component.unregisterKeyboardAction(keyStroke);
	    listener = null;
	} else if (Debug.DEBUG)
	    System.err.println("WARNING: invalid unregister of keystroke "+keyStroke);
    }
    public void setEnabled(boolean _e) {}
    public void setSelected(boolean _p) {}
}
