package com.make.swing;

import java.io.IOException;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.ClipboardOwner;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.datatransfer.StringSelection;
import com.make.util.Debug;

public class ProxyClipboard extends Clipboard 
    implements ClipboardOwner {
    /***properties***********************/
    protected Clipboard original;
    protected boolean lostLock = false;
    /***Constructor**********************/
    public ProxyClipboard(Clipboard _original) {
	super(_original.getName());
	original = _original;
    }
    /***Clipboard*************************/
    public synchronized void setContents(Transferable _contents,
					 ClipboardOwner _owner) {
	super.setContents(_contents, _owner);
	try {
	    lostLock = true;
	    original.setContents(_contents, this);
	    if (original.getContents(this) instanceof StringSelection) {
		try {
		    String data = (String)_contents.getTransferData(DataFlavor.stringFlavor);
		    StringSelection ss = new StringSelection(data);
		    original.setContents(ss, this);
		} catch (UnsupportedFlavorException e) {
		} catch (IOException e) {
		    if (Debug.DEBUG)
			e.printStackTrace();
		}
	    }
	} finally {
	    lostLock = false;
	}
    }
    public synchronized Transferable getContents(Object requestor) {
	Transferable ct = super.getContents(requestor);
	return ct==null
	    ?original.getContents(requestor)
	    :ct;
    }
    /***ClipboardOwner*************************/
    public void lostOwnership(Clipboard _clipboard,
			      Transferable _contents) {
	if (!lostLock) {
	    if (owner!=null) {
		owner.lostOwnership(this, contents);
		owner = null;
	    }
	    contents = null;
	}
    }
}
