package com.make.swing.bt;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.util.Hashtable;
import java.util.Vector;
import javax.swing.JComponent;
import javax.swing.JToolBar;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.AbstractButton;
import javax.swing.JButton;
import javax.swing.JSeparator;
import javax.swing.Box;
import org.w3c.dom.Element;
import com.make.xml.DOMUtil;
import com.make.util.Strings;
import com.make.swing.SwingButton;

public abstract class BarDescription {
    /***properties***************************/
    protected ButtonContainer buttonContainer;
    /***Constructor************************/
    public BarDescription(ButtonContainer _bc) {
	buttonContainer = _bc;
    }
    /***Util*********************************/
    protected ButtonDescription loadChild(Element d) {
	String tag = d.getTagName();
	if (tag.equals("buttonref")) {
	    String name = d.getAttribute("name");
	    ButtonDescription bd = buttonContainer.getButton(name);
	    if (bd==null)
		System.err.println("WARNING: button "+name+" not found");
	    return bd;
	} else if (tag.equals("button"))
	    return new ButtonDescription(d);
	else if (!tag.equals("separator"))
	    System.err.println("WARNING: unknown bar item "+tag);
	return null;
    }
    protected ButtonDescription[] loadChildren(Element l) {
	Element[] chs = DOMUtil.getChildElements(l);
	ButtonDescription[] bd = new ButtonDescription[chs.length];
	for (int z=0; z<chs.length; z++)
	    bd[z] = loadChild(chs[z]);
	return bd;
    }
    /***BarContainer**************************/
    public abstract Container install(Container c, Vector bts, Vector cps);
}
