package com.make.swing.bt;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.util.Hashtable;
import java.util.Vector;
import javax.swing.JComponent;
import javax.swing.JToolBar;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.AbstractButton;
import javax.swing.JButton;
import javax.swing.JSeparator;
import javax.swing.Box;
import org.w3c.dom.Element;
import com.make.xml.DOMUtil;
import com.make.util.Strings;
import com.make.swing.SwingButton;

public class MenuDescription extends PopupMenuDescription {
    /***properties**************************/
    protected String name, label, before;
    protected char mnemonic = 0;
    /***Constructor****************************/
    public MenuDescription(ButtonContainer _bc, Element d) {
	super(_bc, DOMUtil.getUniqueTag(d, "items"));
	name = d.getAttribute("name");
	before = Strings.trim(d.getAttribute("before"));
	Element lbl = DOMUtil.getLocalizedUniqueTag(d, "label");
	if (lbl!=null) {
	    label = DOMUtil.getElementString(lbl);
	    String mn = lbl.getAttribute("mnemonic");
	    if (mn!=null && mn.length()>0)
		mnemonic = mn.charAt(0);
	}
    }
    /***PopupMenuDescription***************************/
    protected Container getMenu(Container c) {
	JMenu menu = (JMenu)findChild(c, name);
	if (menu==null) {
	    menu = new JMenu(label);
	    menu.putClientProperty(ButtonDescription.NAME, name);
	    if (mnemonic!=0)
		menu.setMnemonic(mnemonic);
	    int bidx = before==null ? -1 : findChildIndex(c, before);
	    c.add(menu, bidx);
	}
	menu.getPopupMenu().putClientProperty(MENU, menu);
	return menu.getPopupMenu();
    }
}
