package com.make.swing.bt;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.util.Hashtable;
import java.util.Vector;
import javax.swing.JComponent;
import javax.swing.JToolBar;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.AbstractButton;
import javax.swing.JButton;
import javax.swing.JSeparator;
import javax.swing.Box;
import org.w3c.dom.Element;
import com.make.xml.DOMUtil;
import com.make.util.Strings;
import com.make.swing.SwingButton;

public class PopupMenuDescription extends BarDescription {
    /***CONST********************************/
    public static final String MENU = "FD_MENU";
    /***properties**************************/
    protected String itemsBefore, itemsAfter;
    protected ButtonDescription[] children;
    /***Constructor****************************/
    public PopupMenuDescription(ButtonContainer _bc, Element d) {
	super(_bc);
	itemsBefore = Strings.trim(d.getAttribute("before"));
	itemsAfter = Strings.trim(d.getAttribute("after"));
	children = loadChildren(d);
    }
    /***Internal**********************************/
    protected JComponent createComponent(ButtonDescription bd, Vector bts, Vector cps) {
	AbstractButton ab = bd.createMenuItem();
	bts.addElement(new SwingButton(ab));
	cps.addElement(ab);
	return ab;
    }
    protected int findChildIndex(Container c, String name) {
	Component[] ms = c.getComponents();
	for (int z=0; z<ms.length; z++)
	    if (ms[z] instanceof JComponent &&
		name.equals(((JComponent)ms[z]).getClientProperty(ButtonDescription.NAME)))
		return z;
	return -1;
    }
    protected Component findChild(Container c, String name) {
	int idx = findChildIndex(c, name);
	return idx==-1 ? null : c.getComponent(idx);
    }
    protected void install(Container menu, int idx, Vector bts, Vector cps) {
	Object mn = menu instanceof JComponent
	    ?((JComponent)menu).getClientProperty(MENU)
	    :null;
	for (int z=0; z<children.length; z++,idx++)
	    if (children[z]==null) {
		JComponent jc = new JSeparator();
		jc.putClientProperty(MENU, mn);
		cps.addElement(jc);
		menu.add(jc, idx);
	    } else {
		JComponent jc = createComponent(children[z], bts, cps);
		jc.putClientProperty(MENU, mn);
		menu.add(jc, idx);
	    }
    }
    /***PopupMenuDescription***************************/
    protected Container getMenu(Container c) {
	return c;
    }
    /***BarDescription**********************************/
    public Container install(Container c, Vector bts, Vector cps) {
	Container menu = getMenu(c);
	int idx = -1;
	if (itemsBefore!=null)
	    idx = findChildIndex(menu, itemsBefore);
	if (idx==-1 && itemsAfter!=null) {
	    idx = findChildIndex(menu, itemsAfter);
	    if (idx!=-1)
		idx++;
	}
	if (idx==-1)
	    idx = menu.getComponentCount();
	install(menu, idx, bts, cps);
	return menu;
    }
}
