package com.make.swing.field;

import java.awt.event.ActionEvent;
import java.text.ParseException;
import javax.swing.JCheckBox;

public class CheckBoxField extends DefaultField {
    /***properties****************************/
    protected JCheckBox checkBox;
    protected boolean storeString = false;
    /***Constructor***************************/
    public CheckBoxField(String text) {
	checkBox = new JCheckBox(text);
	checkBox.addActionListener(this);
	setComponent(checkBox);
    }
    public CheckBoxField(String text, boolean _sstring) {
	this(text);
	storeString = _sstring;
    }
    /***Field********************************/
    public void setValue(Object v) throws ParseException {
	if (v instanceof Boolean)
	    checkBox.setSelected(((Boolean)v).booleanValue());
	else if (v instanceof Number)
	    checkBox.setSelected(((Number)v).intValue()!=0);
	else if (v instanceof String)
	    checkBox.setSelected(v.equals("yes") || v.equals("true"));
	else
	    throw new ParseException("unknown checkbox value: "+v, 0);
    }
    public Object getValue() throws ParseException {
	return storeString
	    ?(Object)(checkBox.isSelected() ? "yes" : "no")
	    :new Boolean(checkBox.isSelected());
    }
    /***ActionListener*********************/
    public void actionPerformed(ActionEvent evt) {
	fireValueChanged();
	super.actionPerformed(evt);
    }
}
