package com.make.swing.field;

import java.text.ParseException;
import java.text.DateFormat;
import java.util.Date;
import com.make.util.Strings;

public class DateField extends TextField {
    /***CONST********************************/
    public static final int DATETIME = Strings.DATETIME;
    public static final int DATE = Strings.DATE;
    public static final int TIME = Strings.TIME;
    /***static*****************************/
    public static final DateFormat[] parseFormats = Strings.displayDateFormats;
    /***properties**************************/
    protected DateFormat storeFormat, displayFormat;
    /***Constructor**************************/
    public DateField(boolean storeString, int fmt) {
	storeFormat = storeString?Strings.storeDateFormats[fmt]:null;
	displayFormat = Strings.displayDateFormats[fmt];
    }
    public DateField(DateFormat sf, DateFormat df) {
	storeFormat = sf;
	displayFormat = df;
    }
    /***Field******************************/
    public Object getValue() throws ParseException {
	String s = (String)super.getValue();
	if (s==null)
	    return null;
	Date v = null;
	try {
	    v = displayFormat.parse(s);
	} catch (ParseException e) {
	    for (int z=0; z<parseFormats.length; z++)
		try {
		    v = parseFormats[z].parse(s);
		    break;
		} catch (ParseException e2) {
		}
	    if (v==null)
		throw new ParseException(messages.getString("error.date"), 0);
	}
	return storeFormat==null
	    ?(Object)v
	    :storeFormat.format(v);
    }
    public void setValue(Object _v) throws ParseException {
	if (_v==null)
	    super.setValue(_v);
	else {
	    Date v;
	    if (_v instanceof String)
		v = storeFormat.parse((String)_v);
	    else
		v = (Date)_v;
	    super.setValue(displayFormat.format(v));
	}
    }
}
