package com.make.swing.field;

import java.text.ParseException;
import java.text.NumberFormat;
import com.make.util.Strings;

public class IntegerField extends TextField {
    /***properties**************************/
    protected NumberFormat storeFormat, displayFormat;
    /***Constructor**************************/
    public IntegerField(boolean storeString) {
	storeFormat = storeString?Strings.storeIntegerFormat:null;
	displayFormat = Strings.displayIntegerFormat;
    }
    public IntegerField(NumberFormat sf, NumberFormat df) {
	storeFormat = sf;
	displayFormat = df;
    }
    /***Field******************************/
    public Object getValue() throws ParseException {
	String s = (String)super.getValue();
	if (s==null)
	    return null;
	try {
	    Number v = displayFormat.parse(s);
	    return storeFormat==null
		?(Object)new Integer(v.intValue())
		:storeFormat.format(v);
	} catch (ParseException e) {
	    throw new ParseException(messages.getString("error.integer"), 0);
	}
    }
    public void setValue(Object _v) throws ParseException {
	if (_v==null)
	    super.setValue(_v);
	else {
	    Number v;
	    if (_v instanceof String)
		v = storeFormat.parse((String)_v);
	    else
		v = (Number)_v;
	    super.setValue(displayFormat.format(v));
	}
    }
}
