package com.make.swing.field;

import java.awt.Component;
import java.awt.event.ActionListener;
import java.text.ParseException;
import javax.swing.JTextField;
import javax.swing.event.DocumentListener;
import javax.swing.event.DocumentEvent;
import com.make.util.Strings;
import com.make.swing.GenericButton;
import com.make.swing.ButtonManager;

public class TextField extends DefaultField implements DocumentListener {
    /***properties**************************/
    protected JTextField component;
    protected final GenericButton defaultButton = new GenericButton() {
	    public Object getActionSource() { return component; }
	    public String getActionCommand() { return "ok"; }
	    public void addActionListener(ActionListener al) {
		component.addActionListener(al);
	    }
	    public void removeActionListener(ActionListener al) {
		component.removeActionListener(al);
	    }
	    public void setEnabled(boolean _e) {}
	    public void setSelected(boolean _p) {}
	};
    /***Constructor************************/
    public TextField(int len) {
	component = new JTextField(len);
	component.addActionListener(this);
	component.getDocument().addDocumentListener(this);
	setComponent(component);
    }
    public TextField() {
	this(20);
    }
    /***Field*******************************/
    public void install(ButtonManager bm) {
	super.install(bm);
	bm.installButton(defaultButton);
    }
    public void uninstall(ButtonManager bm) {
	bm.uninstallButton(defaultButton);
	super.uninstall(bm);
    }
    public void setValue(Object v) throws ParseException {
	component.setText(v==null?"":(String)v);
    }
    public Object getValue() throws ParseException {
	return Strings.trim(component.getText());
    }
    /***DefaultField**************************/
    public void fireFocusGained() {
	super.fireFocusGained();
	component.selectAll();
    }
    /***DocumentListener*********************/
    public void insertUpdate(DocumentEvent e) {
	fireValueChanged();
    }    
    public void removeUpdate(DocumentEvent e) {
	fireValueChanged();
    }    
    public void changedUpdate(DocumentEvent e) {
	fireValueChanged();
    }    
}
