package com.make.swing.il;

import java.awt.Component;
import java.util.Vector;
import java.util.Enumeration;
import java.text.ParseException;
import javax.swing.JLabel;
import org.w3c.dom.Element;
import com.make.swing.ButtonManager;

public abstract class ContainerInputLink extends DefaultInputLink
    implements CompositeInputLink {
    /***properties*****************/
    protected Vector fields = new Vector();
    /***Constructor****************/
    public ContainerInputLink(Element vd) {
	super(vd);
    }
    public ContainerInputLink() {
	this(null);
    }
    private void parseException(InputLink il, ParseException e) 
	throws ParseException {
	if (il instanceof CompositeInputLink)
	    throw e;
	else {
	    il.getComponent().requestFocus();
	    Component lbl = il.getLabel();
	    if (lbl instanceof JLabel)
		throw new ParseException
		    ("Eingabefehler im Feld "+((JLabel)lbl).getText()+'\n'+
		     e.getLocalizedMessage(), 0);
	    else
		throw e;
	}
    }
    /***InputLink*************************/
    public void install(ButtonManager bm) {
	super.install(bm);
	for (Enumeration enum=fields.elements();enum.hasMoreElements();)
	    ((InputLink)enum.nextElement()).install(bm);
    }
    public void uninstall(ButtonManager bm) {
	for (Enumeration enum=fields.elements();enum.hasMoreElements();)
	    ((InputLink)enum.nextElement()).uninstall(bm);
	super.uninstall(bm);
    }
    public void reload() {
	for (Enumeration enum=fields.elements(); enum.hasMoreElements();) {
	    InputLink il = (InputLink)enum.nextElement();
	    il.reload();
	}
    }
    public void apply() throws ParseException {
	for (Enumeration enum=fields.elements(); enum.hasMoreElements();) {
	    InputLink il = (InputLink)enum.nextElement();
	    try {
		il.apply();
	    } catch (ParseException e) {
		parseException(il, e);
	    }
	}
    }
    public void checkInput() throws ParseException {
	for (Enumeration enum=fields.elements(); enum.hasMoreElements();) {
	    InputLink il = (InputLink)enum.nextElement();
	    try {
		il.checkInput();
	    } catch (ParseException e) {
		parseException(il, e);
	    }
	}
    }
    public void dispose() {
	for (Enumeration enum=fields.elements(); enum.hasMoreElements();)
	    ((InputLink)enum.nextElement()).dispose();
	super.dispose();
    }
    /***CompositeInputLink*******************/
    public Enumeration getInputLinks() {
	return fields.elements();
    }
}
