package com.make.swing.il;

import java.awt.Component;
import java.text.ParseException;
import org.w3c.dom.Element;
import javax.swing.JLabel;
import com.make.xml.DOMUtil;
import com.make.util.Strings;
import com.make.swing.ButtonManager;

public abstract class DefaultInputLink 
    implements InputLink {
    /***properties**************************/
    protected JLabel label;
    /***Constructor*************************/
    public DefaultInputLink(Element vd) { 
	if (vd!=null) {
	    Element lbl = DOMUtil.getLocalizedUniqueTag(vd, "label");
	    if (lbl!=null) {
		label = new JLabel(DOMUtil.getElementString(lbl));
		String mn = Strings.trim(lbl.getAttribute("mnemonic"));
		if (mn!=null)
		    label.setDisplayedMnemonic(mn.charAt(0));
	    } else {
		String l = Strings.trim(vd.getAttribute("label"));
		if (l!=null)
		    label = new JLabel(l);
	    }
	}
    }
    public DefaultInputLink() {
	this(null);
    }
    /***InputLink*************************/
    public void install(ButtonManager bm) {}
    public void uninstall(ButtonManager bm) {}
    public abstract Component getComponent();
    public Component getLabel() { return label; }
    public abstract void reload();
    public abstract void apply() throws ParseException;
    public abstract void checkInput() throws ParseException;
    public void dispose() {
	label = null;
    }
}
