package com.make.swing.il;

import java.awt.Component;
import java.text.ParseException;
import org.w3c.dom.Element;
import com.make.xml.DOMUtil;
import com.make.swing.field.Field;
import com.make.datamodel.slot.Slot;
import com.make.datamodel.slot.SlotContainer;
import com.make.swing.ButtonManager;

public class FieldInputLink extends DefaultInputLink {
    /***properties**********************/
    protected Slot slot;
    protected Field field;
    /***Constructor*************************/
    public FieldInputLink(Element vd, Slot _slot, Field _field) { 
	super(vd);
	slot = _slot; field = _field;
	reload();
    }
    public FieldInputLink(Element vd, SlotContainer _sc, Field _field) { 
	this(vd, _sc.getSlot(DOMUtil.getElementString(vd, "path")), _field);
    }
    public void setSlot(Slot _slot) {
	slot = _slot;
	reload();
    }
    public void setSlot(Element vd, SlotContainer _sc) {
	setSlot(_sc.getSlot(DOMUtil.getElementString(vd, "path")));
    }
    public void setField(Field _field) {
	field = _field;
	reload();
    }
    /***Info********************************/
    public Field getField() { return field; }
    /***InputLink*************************/
    public void install(ButtonManager bm) {
	super.install(bm);
	field.install(bm);
    }
    public void uninstall(ButtonManager bm) {
	field.uninstall(bm);
	super.uninstall(bm);
    }
    public Component getComponent() { return field.getComponent(); }
    public void reload() {
	if (field!=null)
	    try {
		if (slot==null)
		    field.setValue(null);
		else {
		    Object v;
		    try {
			v = slot.getValue();
		    } catch (ParseException e) {
			v = null;
		    }
		    try {
			field.setValue(v);
		    } catch (ParseException e) {
			field.setValue(null);
		    }
		}
	    } catch (ParseException e) {
	    }
    }
    public void apply() throws ParseException {
	if (field!=null && slot!=null)
	    slot.setValue(field.getValue());
    }
    public void checkInput() throws ParseException {
	Object ov = null;
	try {
	    ov = slot.getValue();
	} catch (ParseException e) {
	}
	slot.setValue(field.getValue());
	try {
	    slot.setValue(ov);
	} catch (ParseException e) {
	}
    }
    public void dispose() {
	if (field!=null) {
	    field.dispose();
	    field = null;
	}
	slot = null;
	super.dispose();
    }
}
