package com.make.swing.il;

import java.awt.Component;
import java.awt.GridLayout;
import java.awt.Dimension;
import java.util.Enumeration;
import java.text.ParseException;
import javax.swing.JPanel;
import javax.swing.Box;
import org.w3c.dom.Element;
import com.make.xml.DOMUtil;

public class GridInputLink extends ContainerInputLink {
    /***properties*****************/
    protected JPanel panel;
    /***Constructor****************/
    public GridInputLink(Element vd, Element[] fsa, InputLinkFactory ilf) {
	super(vd);
	for (int z=0; z<fsa.length; z++) {
	    InputLink il = ilf.createInputLink(fsa[z]);
	    if (il!=null)
		fields.addElement(il);
	}
	panel = new JPanel(new GridLayout(2, fields.size()), false);
	for (Enumeration enum=fields.elements(); enum.hasMoreElements();) {
	    InputLink il = (InputLink)enum.nextElement();
	    Component label = il.getLabel();
	    panel.add(label==null
		      ?Box.createRigidArea(new Dimension(2,2))
		      :label);
	}
	for (Enumeration enum=fields.elements(); enum.hasMoreElements();) {
	    InputLink il = (InputLink)enum.nextElement();
	    panel.add(il.getComponent());
	}
    }
    /***InputLink*************************/
    public Component getComponent() { return panel; }
}
