package com.make.swing.il;

import java.awt.Component;
import java.awt.GridBagLayout;
import java.util.Enumeration;
import java.text.ParseException;
import javax.swing.JPanel;
import org.w3c.dom.Element;
import com.make.swing.MakeDialog;
import com.make.xml.DOMUtil;

public class PanelInputLink extends ContainerInputLink {
    /***properties*****************/
    protected JPanel panel = new JPanel(new GridBagLayout(), false);
    /***Constructor****************/
    public PanelInputLink(Element vd, Element[] fsa, InputLinkFactory ilf) {
	super(vd);
	for (int z=0; z<fsa.length; z++) {
	    InputLink il = ilf.createInputLink(fsa[z]);
	    if (il!=null) {
		fields.addElement(il);
		Component label = il.getLabel();
		if (label!=null)
		    panel.add(label, MakeDialog.labelConstraints);
		Component component = il.getComponent();
		panel.add(component, getConstraints(vd));
	    }
	}
    }
    protected Object getConstraints(Element vd) {
	String cs = vd.getAttribute("constraints");
	if (cs.equals("vertical"))
	    return MakeDialog.verticalConstraints;
	else
	    return MakeDialog.fieldConstraints;
    }
    /***InputLink*************************/
    public Component getComponent() { return panel; }
}
