package com.make.swing.text;

import java.awt.Graphics;
import java.awt.Point;
import javax.swing.Action;
import javax.swing.event.ChangeListener;

public interface Caret {
    // constructor
    public void install(TextComponent c);
    public void deinstall(TextComponent c);
    // event
    public void addChangeListener(ChangeListener l);
    public void removeChangeListener(ChangeListener l);
    public void setBlinkRate(int rate);
    public int getBlinkRate();
    // visual
    public void paint(Graphics g);
    public boolean isVisible();
    public void setVisible(boolean v);
    public boolean isSelectionVisible();
    public void setSelectionVisible(boolean v);
    // position
    public void setMagicCaretPosition(Point p);
    public Point getMagicCaretPosition();
    public int getDot();
    public int getMark();
    public void setDot(int dot);
    public void moveDot(int dot);
};
