package com.make.swing.text;

import java.awt.Font;
import java.util.Hashtable;
import javax.swing.event.UndoableEditListener;
import javax.swing.undo.UndoableEdit;
import javax.swing.text.Segment;
import javax.swing.text.Position;
import javax.swing.text.BadLocationException;

public interface Document {
    // event
    public void addDocumentListener(DocumentListener listener);
    public void removeDocumentListener(DocumentListener listener);
    public void fireDocumentChanged(DocumentEvent evt);
    public DocumentEvent getUndoEvent();
    public void beginUpdate();
    public void endUpdate();
    public boolean inUpdate();
    // undo
    public void addUndoableEditListener(UndoableEditListener listener);
    public void removeUndoableEditListener(UndoableEditListener listener);
    public void postEdit(UndoableEdit uae);
    public void lockUndo();
    public void unlockUndo();
    // data
    public void getText(int offset, int length, Segment txt) throws BadLocationException;
    public Element getRootElement();
    public Element getParagraphElement(int offs, Position.Bias bias) 
	throws BadLocationException;
    // modify
    public void remove(int offs, int len) throws BadLocationException;
    public void insertString(int offset, String str, String format) 
	throws BadLocationException;
    public Hashtable getStyle(String name);
}
