package com.make.swing.text;

import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Insets;
import java.awt.Font;
import javax.swing.Action;
import javax.swing.BoundedRangeModel;
import javax.swing.plaf.ComponentUI;
import javax.swing.text.BadLocationException;
import com.make.swing.text.view.View;

public abstract class TextUI extends ComponentUI {
    public abstract Rectangle modelToView(TextComponent t, int pos) 
	throws BadLocationException;
    public abstract int viewToModel(TextComponent t, Point pt);
    public abstract int getRowStart(TextComponent target, int pos);
    public abstract int getRowEnd(TextComponent target, int pos);
    public abstract int getNextVisualPositionFrom(TextComponent t,
						  int pos, int direction)
	throws BadLocationException;
    public abstract void rebuild();
    public abstract void damageRange(TextComponent t, int p0, int p1);
    public abstract EditorKit getEditorKit(TextComponent t);
    public abstract View getRootView(TextComponent t);
    public abstract Font getFont(TextComponent t, Element el);
}
