package com.make.swing.text.view;

import java.awt.Rectangle;
import javax.swing.text.BadLocationException;
import com.make.swing.text.Element;

public class BrokenBoxView extends BoxView {
    /***properties********************************/
    protected BoxView original;
    protected int axis;
    /***Constructor*****************************/
    public BrokenBoxView(BoxView _o, int axis) {
	super(_o.getElement(), axis);
	original = _o;
	minorCursorWrap = false;
    }
    /***CompositeView******************************/
    protected void loadChildren(ViewFactory f) {}
    protected int getViewIndexAtPosition(int pos) {
	if(pos<getStartOffset() || pos>=getEndOffset())
	    return -1;
	final int n = getViewCount();
	for (int z=0; z<n; z++) {
	    View v = getView(z);
	    final int p0 = v.getStartOffset();
	    final int p1 = v.getEndOffset();
	    if ((pos>=p0) && (pos<p1))
		return z;
	}
	if (pos==getEndOffset())
	    return n-1;
	return -1;
    }
    /***View****************************************/
    public int getStartOffset() { return getView(0).getStartOffset(); }
    public int getEndOffset() { return getView(getViewCount()-1).getEndOffset(); }
    public View createFragment(int p0, int p1) {
	return original.createFragment(p0, p1);
    }
    public int getBreakWeight(int axis, int offset, float pos, float len) {
	return original.getBreakWeight(axis, offset, pos, len);
    }
    public View breakView(int axis, int offset, float pos, float len) {
	return original.breakView(axis, offset, pos, len);
    }
}
