package com.make.swing.text.view;

import java.awt.Shape;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Toolkit;
import javax.swing.text.AttributeSet;
import com.make.swing.text.Element;
import com.make.swing.text.DocumentEvent;
import com.make.swing.text.TextComponent;
import com.make.swing.text.TextUI;

public final class EmptyView extends View {
    /***properties****************************/
    protected FontMetrics metrics;
    protected int start, end;
    /***Constructor******************************/
    public EmptyView(Element el) { 
	super(el); 
	start = el.getStartOffset(); 
	end = el.getEndOffset();
    }
    public EmptyView(Element el, int _position) { 
	super(el); start = end = _position;
    }
    public EmptyView(int _s, int _e) {
	super(null);
	start = _s; end = _e;
    }
    /***View******************************************/
    public int getNextVisualPositionFrom(int pos, int direction) {
	if (DUMP_NEXTVISUAL)
	    System.err.println(this+": nextVisual pos="+pos+" ret="+(pos==-1?start:-1));
	return pos==-1?start:-1;
    }
    public float getPreferredSpan(int axis) { 
	return 0.0f;
    }
    public float getMaximumSpan(int axis) {
	return Integer.MAX_VALUE;
    }
    public Shape modelToView(int pos, Shape a) {
	return a;
    }
    public void paint(Graphics g, Shape allocation) {}
    public int viewToModel(float x, float y, Shape a) {
	return start;
    }
    public int getStartOffset() { return start; }
    public int getEndOffset() { return end; }
    public void documentChanged(DocumentEvent evt, Shape a, ViewFactory vf) {}
}
