package com.make.swing.text.view;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Shape;
import javax.swing.text.BadLocationException;
import com.make.swing.text.TextComponent;

public interface Highlighter {
    public void install(TextComponent c);
    public void deinstall(TextComponent c);
    public Object addHighlight(int p0, int p1, HighlightPainter p) 
	throws BadLocationException;
    public void removeHighlight(Object tag);
    public void removeAllHighlights();
    public void changeHighlight(Object tag, int p0, int p1) 
	throws BadLocationException;
    public Highlight[] getHighlights();
    public void paintHighlights(Graphics g, int p0, int p1,
				Shape viewBounds,
				TextComponent editor, View view);
    /***HighlightPainter**************************/
    public interface HighlightPainter {
	public Shape paint(Graphics g, int p0, int p1,
			   Shape viewBounds, TextComponent editor,
			   View view);
    }
    /***Highlight*******************************/
    public interface Highlight {
	public int getStartOffset();
	public int getEndOffset();
	public HighlightPainter getPainter();
    }
}
