package com.make.swing.text.view;

import javax.swing.text.Position;
import javax.swing.text.BadLocationException;
import java.awt.Graphics;
import java.awt.Shape;
import java.awt.Rectangle;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import org.w3c.dom.Text;
import com.make.swing.text.Element;

public class StyleView extends BoxView implements BreakableView {
    /***properties***************************/
    protected Element element;
    /***Constructor*****************************/
    public StyleView(Element el) {
	super(el, X_AXIS);
	element = el;
	setInsets((short)0,(short)0,(short)0,(short)0);
	minorCursorWrap = false;
    }
    /***BreakableBoxView***********************/
    public View getPoolParent() { return this; }
    public int getPoolViewIndexAt(int position) {
	return getElement().getIndexAt(position);
    }
    public View getPoolView(int index) { return getView(index); }
    public int getPoolViewCount() { return getViewCount(); }
    public View createView(Vector children) {
	return new BrokenStyleView(this, children);
    }
    /***View**********************************/
    public View createFragment(int p0, int p1) {
	return BreakUtil.createFragment(this, p0, p1);
    }
    public int getBreakWeight(int axis, int offset, float x, float len) {
	return axis==X_AXIS && getViewCount()>0
	    ?BreakUtil.getBreakWeight(this, axis, offset, x, len).weight
	    :super.getBreakWeight(axis, offset, x, len);
    }
    public View breakView(int axis, int offset, float x, float len) {
	if (axis==X_AXIS) {
	    return BreakUtil.breakView(this, axis, offset, x, len);
	} else
	    return super.breakView(axis, offset, x, len);
    }
}

class BrokenStyleView extends BrokenBoxView {
    /***properties*********************************/
    protected Vector views;
    /***Constructor*****************************/
    public BrokenStyleView(StyleView _p, Vector _v) {
	super(_p, _p.getAxis());
	views = _v;
    }
    protected void loadChildren(ViewFactory f) {
	final int n = views.size();
	View[] v = new View[n];
	for (int z=0; z<n; z++)
	    v[z] = (View)views.elementAt(z);
	replace(0, 0, v);
    }
}
