package com.make.util;

public class Interval {
    /***properties*******************************/
    protected int first=Integer.MAX_VALUE, last=Integer.MIN_VALUE;
    /***Constructor******************************/
    public Interval() {}
    public Interval(int _f) { first = last = _f; }
    public Interval(int _f, int _l) { first = _f; last = _l; }
    /***Info***************************************/
    public boolean isValid() { return first<=last; }
    public final int getFirst() { return first; }
    public final int getLast() { return last; }
    public final int getCount() { return last-first+1; }
    public final boolean contains(int i) {
	return i>=first && i<=last;
    }
    public final boolean contains(Interval i) {
	return contains(i.getFirst()) && contains(i.getLast());
    }
    public final boolean intersects(Interval i) {
	return contains(i.getFirst()) || contains(i.getLast());
    }
    public final void setEmpty() { first=Integer.MAX_VALUE; last=Integer.MIN_VALUE; }
    public String toString() { return "["+first+"|"+last+"]"; }
    /***Grow****************************************/
    public void removed(int i) {
	if (isValid()) {
	    if (first>i) first--;
	    if (last>=i) last--;
	    if (!isValid()) setEmpty();
	}
    }
    public void inserted(int i) {
	if (isValid()) {
	    if (first>=i) first++;
	    if (last>=i) last++;
	}
    }
    public void include(int i) {
	if (i<first) first = i;
	if (i>last) last = i;
    }
    public void include(Interval i) {
	include(i.getFirst());
	include(i.getLast());
    }
}
