package com.make.xml;

import java.util.Hashtable;
import java.util.Enumeration;
import org.w3c.dom.Element;
import com.make.util.ArrayEnumeration;

public class LookupTable extends Hashtable {
    /***properties*****************************/
    protected Object[] list;
    protected Object nullDisplay, unknownDisplay;
    /***Constructor***************************/
    public LookupTable(Element t) {
	Element[] ks = DOMUtil.getChildElements(t, "key");
	list = new Object[ks.length];
	for (int z=0; z<ks.length; z++) {
	    Element k = ks[z];
	    String src = DOMUtil.getElementString(k, "source");
	    String dest;
	    if (src==null) {
		src = k.getAttribute("source");
		dest = DOMUtil.getElementString(k);
	    } else
		dest = DOMUtil.getElementString(k, "dest");
	    put(src, dest);
	    list[z] = src;
	}
	nullDisplay = DOMUtil.getElementString(t, "null");
	unknownDisplay = DOMUtil.getElementString(t, "unknown");
    }
    /***Info*******************************/
    public Object[] getList() { return list; }
    /***Dictionary***************************/
    public Enumeration keys() {
	return list==null
	    ?super.keys()
	    :new ArrayEnumeration(list);
    }
    public Object get(Object key) {
	if (key==null)
	    return nullDisplay;
	Object result = super.get(key);
	return result==null
	    ?unknownDisplay
	    :result;
    }
}
