package com.make.xml;

import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.apache.xalan.xpath.XPath;
import org.apache.xalan.xpath.XObject;
import org.apache.xalan.xpath.XPathProcessor;
import org.apache.xalan.xpath.XPathProcessorImpl;
import org.apache.xalan.xpath.XPathSupport;
import org.apache.xalan.xpath.XPathSupportDefault;
import org.apache.xalan.xpath.xdom.XercesLiaison;
import org.xml.sax.SAXException;

public abstract class XPathUtil {
    /***static*****************************/
    public static XPathSupport xpathSupport;
    private static XPathProcessor xpathProcessor;
    /***Static**************************/
    public static XPath parse(String s) throws SAXException {
	if (xpathProcessor==null)
	    xpathProcessor = new XPathProcessorImpl();
	XPath xpath = new XPath();
	xpathProcessor.initXPath(xpath, s, null);
	return xpath;
    }
    public static XObject execute(String s, Node ctx) throws SAXException {
	if (xpathSupport==null)
	    xpathSupport = new XercesLiaison();
	return parse(s).execute(xpathSupport, ctx, null);
    }
    public static XObject execute(XPath xp, Node ctx) throws SAXException {
	if (xpathSupport==null)
	    xpathSupport = new XercesLiaison();
	return xp.execute(xpathSupport, ctx, null);
    }
}
