package com.make.xml.slot;

import java.text.ParseException;
import org.w3c.dom.Attr;
import org.w3c.dom.Element;
import com.make.datamodel.slot.Slot;
import com.make.xml.DOMUtil;
import com.make.xml.AttributeType;

public class AttributeSlot implements Slot {
    /***properties*****************************/
    protected Element element;
    protected String attributeName;
    protected Attr attribute;
    protected AttributeType type;
    /***Constructor*****************************/
    public AttributeSlot(Element _el, String _an, AttributeType _type) {
	element = _el; attributeName = _an; type = _type;
	attribute = element.getAttributeNode(attributeName);
    }
    public AttributeSlot(Attr _attr, AttributeType _type) {
	attribute = _attr; type = _type;
	element = (Element)attribute.getParentNode();
	attributeName = attribute.getName();
    }
    public AttributeSlot(Attr _attr) {
	this(_attr, null);
    }
    /***Slot**********************************/
    public void setValue(Object v) throws ParseException {
	if (v==null) {
	    if (attribute!=null) {
		if (type!=null && type.isRequired())
		    throw new ParseException("Bitte geben Sie hier einen Wert ein.", 0);
		element.removeAttributeNode(attribute);
		/*if (element.getChildNodes().getLength()==0 &&
		  element.getAttributes().getLength()==0)
		  remove element from its parent? */
	    }
	} else {
	    if (attribute==null) {
		attribute = element.getOwnerDocument().createAttribute(attributeName);
		element.setAttributeNode(attribute);
	    }
	    attribute.setValue(v.toString());
	}
    }
    public Object getValue() throws ParseException {
	return attribute.getValue();
    }
}
