package com.make.xml.slot;

import java.util.StringTokenizer;
import org.w3c.dom.Element;
import org.w3c.dom.Attr;
import org.w3c.dom.Node;
import org.w3c.dom.Text;
import com.make.datamodel.slot.Slot;
import com.make.datamodel.slot.SlotContainer;
import com.make.xml.DocumentType;
import com.make.xml.ElementType;
import com.make.xml.DOMUtil;
import com.make.xml.XPathUtil;
import com.make.util.Strings;

public class DOMSlotContainer implements SlotContainer {
    /***properties**********************/
    protected DocumentType documentType;
    protected Node context;
    /***Constructor**********************/
    public DOMSlotContainer(DocumentType _dt, Node _ctx) {
	documentType = _dt; context = _ctx;
    }
    /***SlotFactory***********************/
    public Slot getSlot(Object key) {
	if (key instanceof String) {
	    /*NodeList nl = XPathUtil.execute((String)key, context).nodeset();
	      if (nl.getLength()==0) {
	      } else {
	      Node n = nl.item(0);
	      if (n instanceof Attr)
	      return new AttributeSlot((Attr)n);
	      else if (n instanceof Element)
	      return new ElementSlot((Element)n);
	      }*/
	    String path = (String)key;
	    StringTokenizer st = new StringTokenizer(path, "/");
	    Element el = (Element)context;
	    while (el!=null && st.hasMoreTokens()) {
		String t = Strings.trim(st.nextToken());
		if (t==null) {
		} else if (t.charAt(0)=='@') {
		    String an = t.substring(1);
		    Attr a = el.getAttributeNode(an);
		    if (a==null) {
			a = el.getOwnerDocument().createAttribute(an);
			el.setAttributeNode(a);
		    }
		    ElementType et = documentType==null
			?null
			:documentType.getElementType(el.getTagName());
		    return new AttributeSlot(a, et==null?null:et.getAttribute(an));
		} else {
		    Element ch = DOMUtil.getUniqueTag(el, t);
		    if (ch==null) {
			ch = el.getOwnerDocument().createElement(t);
			el.appendChild(ch);
		    }
		    el = ch;
		}
	    }
	    return new ElementSlot(el);
	} else
	    return null;
    }
}
